# Visa Merchant Offers Resource Center
Get access to pre-negotiated offers from top merchants around the globe instantly.

## Version: 1

### Servers

| URL | Description |
| --- | ----------- |
| https://sandbox.api.visa.com | Sandbox server |

---
## Reference Data API
The Reference Data API provides developers the set of available reference data from VMORC. Use the "key" information of each reference data option to conduct filtered offer requests.

### [GET] /vmorc/data/v1/merchantAddress
**Retrieve Data by Merchant Address**

Get merchant address data

#### Parameters

| Name | Located in | Description | Required | Schema | Style | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ----- | ------- |
| start_index | query | Optional. A maximum of 500 address records are returned in the response. The index indicates which addresses within the sorted results (by merchant id) to start returning in the response. Accepts an integer. Default set to 1 | No | integer | form | Yes |
| merchantIds | query | Required. Returns merchant address data for the requested merchant ids. Separate multiple ids by commas | Yes | string | form | Yes |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | ok | **application/json**: { **"StartIndex"**: integer, **"ReturnedResults"**: integer, **"MerchantAddresses"**: [ object ], **"TotalFoundResults"**: integer }<br> |

### [GET] /vmorc/data/v1/merchant
**Retrieve Data by Merchant**

Retrieve Data by merchant

#### Parameters

| Name | Located in | Description | Required | Schema | Style | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ----- | ------- |
| start_index | query | Optional. A maximum of 500 merchant records are returned in the response. The index indicates which merchant within the alphabetically sorted results to start returning in the response. Accepts an integer. Default set to 1 | No | integer | form | Yes |
| program | query | Optional. Returns merchant data for approved and active offers (includes expired offers) that belong to the specified program | No | string | form | Yes |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | ok | **application/json**: { **"language"**: string, **"Merchants"**: [ { **"key"**: integer, **"value"**: string, **"images"**: [ { **"key"**: integer, **"fileName"**: string, **"languages"**: [ object ], **"logoAltTag"**: string, **"description"**: string, **"languageIds"**: [ object ], **"promotionId"**: integer, **"fileLocation"**: string, **"promotionIds"**: [ object ], **"imageFileSize"**: string, **"imageFileWidth"**: string, **"imageFileHeight"**: string, **"imageResolution"**: string, **"promotionChannel"**: string, **"promotionChannels"**: [ object ] } ], **"languageId"**: integer, **"translations"**: [ { **"value"**: string, **"languageId"**: integer } ], **"alternativeNames"**: [ { **"key"**: integer, **"value"**: string } ] } ], **"StartIndex"**: integer, **"ReturnedResults"**: integer, **"TotalFoundResults"**: integer }<br> |

### [GET] /vmorc/data/v1/ref
**Retrieve Data by Reference**

Retrieve Data by reference

#### Parameters

| Name | Located in | Description | Required | Schema | Style | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ----- | ------- |
| resources | query | Optional. Request for specific reference data types in theresponse.Provide one reference data type or a comma-delimited string of reference data types. Default returns all available referece data types.   Refer to <a href="/guides/request_response_codes#resources">resources</a> for supported resource values. | No | string | form | Yes |
| languages | query | Optional. A comma-delimited string of languageIds. For the reference data that may specify a language, the response will only return translations that match the requested languageIds. Default returns all existing translations.   Refer to <a href="/guides/request_response_codes#resources">resources</a> for supported resources that support a specific language. | No | string | form | Yes |
| programIds | query | Optional. Returns reference data for approved and active offers (includes expired offers) that belong to the specified program. Two additional responses of "promoting_countries" and "redemption_countries" are returned in this request. | No | string | form | Yes |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | ok | **application/json**: { **"program"**: [ { **"key"**: integer, **"value"**: string, **"languageId"**: integer } ], **"language"**: [ { **"key"**: integer, **"value"**: string } ], **"card_product"**: [ { **"key"**: integer, **"value"**: string, **"languageId"**: integer, **"translations"**: [ { **"value"**: string, **"languageId"**: integer } ] } ], **"region_country"**: [ { **"key"**: integer, **"value"**: string, **"countries"**: [ { **"key"**: integer, **"value"**: string, **"languageId"**: integer, **"translations"**: [ { **"value"**: string, **"languageId"**: integer } ] } ], **"languageId"**: integer } ], **"business_segment"**: [ { **"key"**: integer, **"value"**: string, **"languageId"**: integer, **"translations"**: [ { **"value"**: string, **"languageId"**: integer } ] } ], **"card_payment_type"**: [ { **"key"**: integer, **"value"**: string, **"languageId"**: integer, **"translations"**: [ { **"value"**: string, **"languageId"**: integer } ] } ], **"promotion_channel"**: [ { **"key"**: integer, **"value"**: string, **"languageId"**: integer, **"translations"**: [ { **"value"**: string, **"languageId"**: integer } ] } ], **"redemption_channel"**: [ { **"key"**: integer, **"value"**: string, **"languageId"**: integer, **"translations"**: [ { **"value"**: string, **"languageId"**: integer } ] } ], **"promotion_countries"**: [ { **"key"**: integer, **"value"**: string, **"countries"**: [ { **"key"**: integer, **"value"**: string, **"languageId"**: integer, **"translations"**: [ { **"value"**: string, **"languageId"**: integer } ] } ], **"languageId"**: integer } ], **"category_subcategory"**: [ { **"key"**: integer, **"value"**: string, **"languageId"**: integer, **"translations"**: [ { **"value"**: string, **"languageId"**: integer } ], **"subcategories"**: [ { **"key"**: integer, **"value"**: string, **"languageId"**: integer, **"translations"**: [ { **"value"**: string, **"languageId"**: integer } ] } ] } ], **"redemption_countries"**: [ { **"key"**: integer, **"value"**: string, **"countries"**: [ { **"key"**: integer, **"value"**: string, **"languageId"**: integer, **"translations"**: [ { **"value"**: string, **"languageId"**: integer } ] } ], **"languageId"**: integer } ] }<br> |

---
## Offers Data API
The Offers Data API provides developers a quick and easy way to retrieve offer information from VMORC. The API allows you to retrieve all your available offers or retrieve specific offers. In an offer-specific request, you may choose to filter your accessible offers by certain offer attributes or you may request for offers by its identifiers.

### [GET] /vmorc/offers/v1/bycontentid
**Retrieve Offers by a Content Id**

Retrieve the language-specific offer. Each specified contentID returns one offer content object. Query param "contentId" is required.

#### Parameters

| Name | Located in | Description | Required | Schema | Style | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ----- | ------- |
| start_index | query | A maximum of 500 offer results may be returned in the response. The parameter specifies the index of the total available offer results to start returning in the response.  | No | integer | form | Yes |
| max_offers | query | Optional. A maximum of 500 offer results are returned in the offer response. The index indicates the maximum number of offers to return in the response. Accepts an integer (greater than 0; less than or equal to 500). Default set to 500 | No | integer | form | Yes |
| business_segment | query | Filter offers by business segments. Provide one "key" integer or a comma-delimited string of "key" integers  Refer to <a href="/guides/request_response_codes#business_segments">business_segments</a> for sample values and keys. | No | string | form | Yes |
| card_payment_type | query | Filter offers by card payment types. Provide one "key" integer or a comma-delimited string of "key" integers  Refer to <a href="/guides/request_response_codes#card_payment_types">card_payment_types</a> for sample values and keys.  | No | string | form | Yes |
| card_product | query | Filter offers by card products. Provide one "key" integer or a comma-delimited string of "key" integers  Refer to <a href="/guides/request_response_codes#card_product">card_product</a> for sample values and keys. | No | string | form | Yes |
| category | query | Filter offers by offer categories. Provide one "key" integer or a comma-delimited string of "key" integers  Refer to <a href="/guides/request_response_codes#category_and_subcategory">category_subcategory</a> for sample values and keys.  | No | string | form | Yes |
| subcategory | query | Filter offers by offer subcategories. Provide one "key" integer or a comma-delimited string of "key" integers  Refer to <a href="/guides/request_response_codes#category_and_subcategory">category_subcategory</a> for sample values and keys.  | No | string | form | Yes |
| merchant | query | Filter offers by merchants. Provide one "key" integer or a comma-delimited string of "key" integers   Refer to <a href="/guides/request_response_codes#merchant">merchant</a> for sample values and keys. | No | string | form | Yes |
| program | query | Filter offers by programs. Provide one "key" integer or a comma-delimited string of "key" integers  Refer to <a href="/guides/request_response_codes#program">program</a> for sample values and keys. | No | string | form | Yes |
| promotion_channel | query | Filter offers by promotion channels. Provide one "key" integer or a comma-delimited string of "key" integers   Refer to <a href="/guides/request_response_codes#promotion_channel">promotion_channel</a> for sample values and keys. | No | string | form | Yes |
| promoting_region | query | Filter offers by promoting regions. Provide one "key" integer or a comma-delimited string of "key" integers  Refer to <a href="/guides/request_response_codes#region">region</a> for sample values and keys. | No | string | form | Yes |
| promoting_country | query | Filter offers by promoting countries. Provide one "key" integer or a comma-delimited string of "key" integers    Refer to <a href="/guides/request_response_codes#country">country</a> for sample values and keys. | No | string | form | Yes |
| redemption_region | query | Filter offers by redemption regions. Provide one "key" integer or a comma-delimited string of "key" integers    Refer to <a href="/guides/request_response_codes#region">region</a> for sample values and keys. | No | string | form | Yes |
| redemption_country | query | Filter offers by redemption countries. Provide one "key" integer or a comma-delimited string of "key" integers  Refer to <a href="/guides/request_response_codes#country">country</a> for sample values and keys. | No | string | form | Yes |
| merchant_region | query | Filter for offers that have been assigned a merchant address in at least one merchant address region parameter   Refer to <a href="/guides/request_response_codes#region">region</a> for sample values and keys. | No | string | form | Yes |
| merchant_county | query | Filter for offers that have been assigned a merchant address in at least one merchant address country parameter    Refer to <a href="/guides/request_response_codes#country">country</a> for sample values and keys. | No | string | form | Yes |
| language | query | Filter offers by offer languages. Provide one "key" integer or a comma-delimited string of "key" integers | No | string | form | Yes |
| expired | query | Request for expired offers. Provide a boolean value. Default set to value to "false". | No | boolean | form | Yes |
| validfrom | query | Request for offers where the offer's redemption end date is on or after the provided date (in GMT). Accepts a date formatted by: yyyyMMdd e.g. 1, If validfrom=20150101 is provided, this returns eligible offers that end on or after January 1, 2015 e.g. 2, If validfrom=20150101&validto=20150131, this will return eligible offers that end on or after January 1, 2015 and start on or before January 31, 2015 (valid during at least one day in January 2015). | No | string | form | Yes |
| validto | query | Request for offers where the offer’s redemption start date is before or on the provided date (in GMT). Accepts a date formatted   by: yyyyMMdd e.g. 1, If validto=20150131 is provided, this will     return eligible offers that start before or on January 31,       2015 e.g. 2, If validfrom=20150101&validto=20150131, this will return eligible offers that end on or after January 1, 2015 and start on or before January 31, 2015 (valid during at least one day in January 2015). | No | string | form | Yes |
| promotedfrom | query | Request for offers where the offer’s promotion end date is on or  after the provided date (in GMT). Accepts a date formatted by: yyyyMMdd e.g. 1, If promotedfrom=20150101 is provided, this will / return eligible offers where the promotion ends on or after January 1, 2015 e.g. 2, If promotedfrom=20150101&promotedto=20150131, this will return eligible offers where the promotion ends on or after January 1, 2015 and start on or before January 31, 2015 (promoted at least one day in January 2015). | No | string | form | Yes |
| promotedto | query | Request for offers where the offer’s promotion start date is before or on the provided date (in GMT). Accepts a date formatted by: yyyyMMdd e.g. 1, If promotedto=20150131 is provided, this will return eligible offers where the promotion starts before or on January 31, 2015 e.g. 2, If promotedfrom=20150101&promotedto=20150131, this will return eligible offers where the promotion ends on or after January 1, 2015 and start on or before January 31, 2015 (promoted at least one day in January 2015). | No | string | form | Yes |
| updatefrom | query | Request for offers where the provided date is before or on an offer’s last modified date/time (in GMT). Accepts a date formatted by: yyyyMMdd | No | string | form | Yes |
| updateto | query | Request for offers where the provided date is after or on an       offer’s last modified date/time (in GMT). Accepts a date     formatted by: yyyyMMdd | No | string | form | Yes |
| featured | query | Request for featured offers. Provide a boolean value. | No | boolean | form | Yes |
| bins | query | Request for offers that fulfill one or more BIN options by inputting the exact desired bin value(s). Comma-delimit for multiple values | No | string | form | Yes |
| rpins | query | Request for offers that fulfill one or more RPIN options by inputting the exact desired rpin value(s). Comma-delimit for multiple values | No | string | form | Yes |
| bins_to_rpins | query | Request for offers that fulfill one or more BIN to RPIN pairing options by inputting the exact desired bin value, a tilde("~"), and the exact rpin value. | No | string | form | Yes |
| accountranges | query | Request for offers that fulfill a specific Account Range by     providing either  a "from" prefix value OR a "to" prefix value OR a "from" and a "to" prefix values. Each provided prefix value   must be a minimum of 4 digits. Each account range request must contain a colon(":") to distinguish between the "from" and "to" values (even if only one boundary is provided). | No | string | form | Yes |
| accountranges_to_rpins | query | Request for offers that fulfill a specific Account Range to RPIN pairing by providing either a "from" prefix value ~ RPIN OR a "to" prefix value ~ RPIN OR a "from" and a "to" prefix values ~ RPIN. Each provided account range prefix value must be a minimum of 4 digits. Each account range portion of the request must contain a colon(":") to distinguish between the "from" and "to" values (even if only one boundary is provided). Use a tilde("~") to separate the account range from the exact desired rpin. | No | string | form | Yes |
| pans | query | Request for offers by PAN (must be a minimum of 16 digits). The provided PAN is padded-right with "0" to a length of 21 digits. The system returns the offers where the padded value is within the subset of at least one of the offer's account range assignments. | No | string | form | Yes |
| non_cardAttribute | query | Request for offers that do not have assignments to card attribute fields. Provide a boolean value. Default sets value to "false". | No | boolean | form | Yes |
| origin | query | Required for applying a geolocation filter. Input the origin by specifying the latitude, a comma (","), and the longitude. Coordinates must be inputted in decimal degree format. The accepted range for latitude is between -90 and 90, inclusive. The accepted range for longitude is between -180 and 180, inclusive. | No | string | form | Yes |
| radius | query | Optional for applying a geolocation filter.. A maximum radius of 1000 (kilometers) or 621.371 (miles) is accepted. Default sets to 60 miles (or 100 kilometers if the "unit" geolocation parameter has been set to "km"). | No | number | form | Yes |
| unit | query | Optional for applying a geolocation filter.. Indicate the distance unit of miles or kilometers. Default sets to miles. To use kilometers, specify "km". | No | number | form | Yes |
| non_geo | query | Optional for applying a geolocation filter.. Request for offers that have not been assigned merchant addresses with geo-location(latitude/longitude) coordinates. At minimum, an origin must be also provided to call this flag. Accepts a boolean value - By default, the boolean value is set to false.  | No | boolean | form | Yes |
| contentid | query | Retrieve offers by their content ids. Provide an content id integer or a comma-delimited string of content id integers | No | string | form | Yes |
| offerid | query | Retrieve offers by their offer ids. Provide an offer id integer or a comma-delimited string of offer id integers | No | string | form | Yes |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | ok | **application/json**: { **"Offers"**: [ { **"bins"**: [ { **"ubid"**: integer, **"value"**: string, **"companyName"**: string } ], **"fAQs"**: { **"text"**: string, **"richText"**: string }, **"rpins"**: [ { **"ubid"**: integer, **"value"**: string, **"companyName"**: string, **"description"**: string } ], **"qrCode"**: { **"key"**: integer, **"description"**: string, **"imageAltTag"**: string, **"fileLocation"**: string, **"imageFileSize"**: string, **"imageFileWidth"**: string, **"imageFileHeight"**: string, **"imageResolution"**: string, **"offerImagePromotionChannels"**: [ object ], **"offerImagePromotionChannelIds"**: [ object ] }, **"barcode"**: { **"key"**: integer, **"description"**: string, **"imageAltTag"**: string, **"fileLocation"**: string, **"imageFileSize"**: string, **"imageFileWidth"**: string, **"imageFileHeight"**: string, **"imageResolution"**: string, **"offerImagePromotionChannels"**: [ object ], **"offerImagePromotionChannelIds"**: [ object ] }, **"offerId"**: integer, **"soldOut"**: boolean, **"language"**: string, **"supData1"**: { **"text"**: string, **"richText"**: string }, **"supData2"**: { **"text"**: string, **"richText"**: string }, **"supData3"**: { **"text"**: string, **"richText"**: string }, **"supData4"**: { **"text"**: string, **"richText"**: string }, **"imageList"**: [ { **"key"**: integer, **"description"**: string, **"imageAltTag"**: string, **"fileLocation"**: string, **"imageFileSize"**: string, **"imageFileWidth"**: string, **"imageFileHeight"**: string, **"imageResolution"**: string, **"offerImagePromotionChannels"**: [ object ], **"offerImagePromotionChannelIds"**: [ object ] } ], **"offerCopy"**: { **"text"**: string, **"richText"**: string }, **"offerType"**: [ { **"key"**: integer, **"value"**: string } ], **"programId"**: integer, **"visaTerms"**: { **"text"**: string, **"richText"**: string }, **"languageId"**: integer, **"offerTitle"**: string, **"shareTitle"**: string, **"binstorpins"**: [ { **"BIN"**: { **"ubid"**: integer, **"value"**: string, **"companyName"**: string }, **"RPIN"**: { **"ubid"**: integer, **"value"**: string, **"companyName"**: string, **"description"**: string } } ], **"indexNumber"**: integer, **"offerSource"**: string, **"offerStatus"**: string, **"programName"**: string, **"isOfferEvent"**: boolean, **"merchantList"**: [ { **"merchant"**: string, **"merchantId"**: integer, **"merchantImages"**: [ { **"key"**: integer, **"fileName"**: string, **"languages"**: [ object ], **"logoAltTag"**: string, **"description"**: string, **"languageIds"**: [ object ], **"promotionId"**: integer, **"fileLocation"**: string, **"promotionIds"**: [ object ], **"imageFileSize"**: string, **"imageFileWidth"**: string, **"imageFileHeight"**: string, **"imageResolution"**: string, **"promotionChannel"**: string, **"promotionChannels"**: [ object ] } ], **"merchantAddress"**: [ { **"key"**: integer, **"city"**: string, **"state"**: string, **"address1"**: string, **"address2"**: string, **"distance"**: string, **"latitude"**: string, **"languages"**: [ object ], **"longtitude"**: string, **"postalCode"**: string, **"countryName"**: string, **"indexNumber"**: integer, **"languageIds"**: [ object ], **"merchantKey"**: integer, **"languageName"**: string, **"merchantValue"**: string } ] } ], **"accountranges"**: [ { **"ubid"**: integer, **"valueTo"**: string, **"valueFrom"**: string, **"companyName"**: string } ], **"dateLocations"**: [ { **"city"**: string, **"state"**: string, **"endDate"**: string, **"address1"**: string, **"address2"**: string, **"latitude"**: string, **"isSoldOut"**: boolean, **"longitude"**: string, **"startDate"**: string, **"postalCode"**: string, **"countryName"**: string, **"dateLocationId"**: integer } ], **"eventSubTitle"**: string, **"merchantTerms"**: { **"text"**: string, **"richText"**: string }, **"offerMetadata"**: [ { **"metaId"**: integer, **"metaKey"**: string, **"metaValue"**: string } ], **"redemptionUrl"**: string, **"currentVersion"**: integer, **"offerContentId"**: integer, **"redemptionCode"**: string, **"validityToDate"**: string, **"activeIndicator"**: boolean, **"cardPaymentType"**: [ { **"key"**: integer, **"value"**: string } ], **"cardProductList"**: [ { **"key"**: integer, **"value"**: string } ], **"promotionToDate"**: string, **"redemptionEmail"**: string, **"validityFromDate"**: string, **"promotionFromDate"**: string, **"creativeGuidelines"**: string, **"offerSourceContact"**: string, **"promotingCountries"**: [ { **"key"**: integer, **"value"**: string } ], **"businessSegmentList"**: [ { **"key"**: integer, **"value"**: string } ], **"redemptionCountries"**: [ { **"key"**: integer, **"value"**: string } ], **"redemptionTelephone"**: { **"text"**: string, **"richText"**: string }, **"accountrangestorpins"**: [ { **"RPIN"**: { **"ubid"**: integer, **"value"**: string, **"companyName"**: string, **"description"**: string }, **"AccountRange"**: { **"ubid"**: integer, **"valueTo"**: string, **"valueFrom"**: string, **"companyName"**: string } } ], **"lastModifiedDateTime"**: string, **"promotionChannelList"**: [ { **"key"**: integer, **"value"**: string } ], **"promotionRestictions"**: { **"text"**: string, **"richText"**: string }, **"offerShortDescription"**: { **"text"**: string, **"richText"**: string }, **"redemptionChannelList"**: [ { **"key"**: integer, **"value"**: string } ], **"creativeApprovalsEmail"**: string, **"featuredOfferIndicator"**: boolean, **"legalCountryExclusions"**: { **"text"**: string, **"richText"**: string }, **"categorySubcategoryList"**: [ { **"key"**: integer, **"value"**: string, **"subcategories"**: [ { **"key"**: integer, **"value"**: string } ] } ], **"socialMediaSharingTypes"**: [ { **"key"**: integer, **"value"**: string } ], **"redemptionFormatInstructions"**: string } ], **"StartIndex"**: integer, **"ReturnedResults"**: integer, **"TotalFoundResults"**: integer }<br> |
| 400 | Invalid query |  |
| default | Unexpected error |  |

### [GET] /vmorc/offers/v1/all
**Retrieve All Offers**

Retrieve all accessible offers in the response.

#### Parameters

| Name | Located in | Description | Required | Schema | Style | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ----- | ------- |
| start_index | query | A maximum of 500 offer results may be returned in the response. The parameter specifies the index of the total available offer results to start returning in the response.  | No | integer | form | Yes |
| max_offers | query | Optional. A maximum of 500 offer results are returned in the offer response. The index indicates the maximum number of offers to return in the response. Accepts an integer (greater than 0; less than or equal to 500). Default set to 500 | No | integer | form | Yes |
| business_segment | query | Filter offers by business segments. Provide one "key" integer or a comma-delimited string of "key" integers  Refer to <a href="/guides/request_response_codes#business_segments">business_segments</a> for sample values and keys. | No | string | form | Yes |
| card_payment_type | query | Filter offers by card payment types. Provide one "key" integer or a comma-delimited string of "key" integers  Refer to <a href="/guides/request_response_codes#card_payment_types">card_payment_types</a> for sample values and keys.  | No | string | form | Yes |
| card_product | query | Filter offers by card products. Provide one "key" integer or a comma-delimited string of "key" integers  Refer to <a href="/guides/request_response_codes#card_product">card_product</a> for sample values and keys. | No | string | form | Yes |
| category | query | Filter offers by offer categories. Provide one "key" integer or a comma-delimited string of "key" integers  Refer to <a href="/guides/request_response_codes#category_and_subcategory">category_subcategory</a> for sample values and keys.  | No | string | form | Yes |
| subcategory | query | Filter offers by offer subcategories. Provide one "key" integer or a comma-delimited string of "key" integers  Refer to <a href="/guides/request_response_codes#category_and_subcategory">category_subcategory</a> for sample values and keys.  | No | string | form | Yes |
| merchant | query | Filter offers by merchants. Provide one "key" integer or a comma-delimited string of "key" integers   Refer to <a href="/guides/request_response_codes#merchant">merchant</a> for sample values and keys. | No | string | form | Yes |
| program | query | Filter offers by programs. Provide one "key" integer or a comma-delimited string of "key" integers  Refer to <a href="/guides/request_response_codes#program">program</a> for sample values and keys. | No | string | form | Yes |
| promotion_channel | query | Filter offers by promotion channels. Provide one "key" integer or a comma-delimited string of "key" integers   Refer to <a href="/guides/request_response_codes#promotion_channel">promotion_channel</a> for sample values and keys. | No | string | form | Yes |
| promoting_region | query | Filter offers by promoting regions. Provide one "key" integer or a comma-delimited string of "key" integers  Refer to <a href="/guides/request_response_codes#region">region</a> for sample values and keys. | No | string | form | Yes |
| promoting_country | query | Filter offers by promoting countries. Provide one "key" integer or a comma-delimited string of "key" integers    Refer to <a href="/guides/request_response_codes#country">country</a> for sample values and keys. | No | string | form | Yes |
| redemption_region | query | Filter offers by redemption regions. Provide one "key" integer or a comma-delimited string of "key" integers    Refer to <a href="/guides/request_response_codes#region">region</a> for sample values and keys. | No | string | form | Yes |
| redemption_country | query | Filter offers by redemption countries. Provide one "key" integer or a comma-delimited string of "key" integers  Refer to <a href="/guides/request_response_codes#country">country</a> for sample values and keys. | No | string | form | Yes |
| merchant_region | query | Filter for offers that have been assigned a merchant address in at least one merchant address region parameter   Refer to <a href="/guides/request_response_codes#region">region</a> for sample values and keys. | No | string | form | Yes |
| merchant_county | query | Filter for offers that have been assigned a merchant address in at least one merchant address country parameter    Refer to <a href="/guides/request_response_codes#country">country</a> for sample values and keys. | No | string | form | Yes |
| language | query | Filter offers by offer languages. Provide one "key" integer or a comma-delimited string of "key" integers | No | string | form | Yes |
| expired | query | Request for expired offers. Provide a boolean value. Default set to value to "false". | No | boolean | form | Yes |
| validfrom | query | Request for offers where the offer's redemption end date is on or after the provided date (in GMT). Accepts a date formatted by: yyyyMMdd e.g. 1, If validfrom=20150101 is provided, this returns eligible offers that end on or after January 1, 2015 e.g. 2, If validfrom=20150101&validto=20150131, this will return eligible offers that end on or after January 1, 2015 and start on or before January 31, 2015 (valid during at least one day in January 2015). | No | string | form | Yes |
| validto | query | Request for offers where the offer’s redemption start date is before or on the provided date (in GMT). Accepts a date formatted   by: yyyyMMdd e.g. 1, If validto=20150131 is provided, this will     return eligible offers that start before or on January 31,       2015 e.g. 2, If validfrom=20150101&validto=20150131, this will return eligible offers that end on or after January 1, 2015 and start on or before January 31, 2015 (valid during at least one day in January 2015). | No | string | form | Yes |
| promotedfrom | query | Request for offers where the offer’s promotion end date is on or  after the provided date (in GMT). Accepts a date formatted by: yyyyMMdd e.g. 1, If promotedfrom=20150101 is provided, this will / return eligible offers where the promotion ends on or after January 1, 2015 e.g. 2, If promotedfrom=20150101&promotedto=20150131, this will return eligible offers where the promotion ends on or after January 1, 2015 and start on or before January 31, 2015 (promoted at least one day in January 2015). | No | string | form | Yes |
| promotedto | query | Request for offers where the offer’s promotion start date is before or on the provided date (in GMT). Accepts a date formatted by: yyyyMMdd e.g. 1, If promotedto=20150131 is provided, this will return eligible offers where the promotion starts before or on January 31, 2015 e.g. 2, If promotedfrom=20150101&promotedto=20150131, this will return eligible offers where the promotion ends on or after January 1, 2015 and start on or before January 31, 2015 (promoted at least one day in January 2015). | No | string | form | Yes |
| updatefrom | query | Request for offers where the provided date is before or on an offer’s last modified date/time (in GMT). Accepts a date formatted by: yyyyMMdd | No | string | form | Yes |
| updateto | query | Request for offers where the provided date is after or on an       offer’s last modified date/time (in GMT). Accepts a date     formatted by: yyyyMMdd | No | string | form | Yes |
| featured | query | Request for featured offers. Provide a boolean value. | No | boolean | form | Yes |
| bins | query | Request for offers that fulfill one or more BIN options by inputting the exact desired bin value(s). Comma-delimit for multiple values | No | string | form | Yes |
| rpins | query | Request for offers that fulfill one or more RPIN options by inputting the exact desired rpin value(s). Comma-delimit for multiple values | No | string | form | Yes |
| bins_to_rpins | query | Request for offers that fulfill one or more BIN to RPIN pairing options by inputting the exact desired bin value, a tilde("~"), and the exact rpin value. | No | string | form | Yes |
| accountranges | query | Request for offers that fulfill a specific Account Range by     providing either  a "from" prefix value OR a "to" prefix value OR a "from" and a "to" prefix values. Each provided prefix value   must be a minimum of 4 digits. Each account range request must contain a colon(":") to distinguish between the "from" and "to" values (even if only one boundary is provided). | No | string | form | Yes |
| accountranges_to_rpins | query | Request for offers that fulfill a specific Account Range to RPIN pairing by providing either a "from" prefix value ~ RPIN OR a "to" prefix value ~ RPIN OR a "from" and a "to" prefix values ~ RPIN. Each provided account range prefix value must be a minimum of 4 digits. Each account range portion of the request must contain a colon(":") to distinguish between the "from" and "to" values (even if only one boundary is provided). Use a tilde("~") to separate the account range from the exact desired rpin. | No | string | form | Yes |
| pans | query | Request for offers by PAN (must be a minimum of 16 digits). The provided PAN is padded-right with "0" to a length of 21 digits. The system returns the offers where the padded value is within the subset of at least one of the offer's account range assignments. | No | string | form | Yes |
| non_cardAttribute | query | Request for offers that do not have assignments to card attribute fields. Provide a boolean value. Default sets value to "false". | No | boolean | form | Yes |
| origin | query | Required for applying a geolocation filter. Input the origin by specifying the latitude, a comma (","), and the longitude. Coordinates must be inputted in decimal degree format. The accepted range for latitude is between -90 and 90, inclusive. The accepted range for longitude is between -180 and 180, inclusive. | No | string | form | Yes |
| radius | query | Optional for applying a geolocation filter.. A maximum radius of 1000 (kilometers) or 621.371 (miles) is accepted. Default sets to 60 miles (or 100 kilometers if the "unit" geolocation parameter has been set to "km"). | No | number | form | Yes |
| unit | query | Optional for applying a geolocation filter.. Indicate the distance unit of miles or kilometers. Default sets to miles. To use kilometers, specify "km". | No | number | form | Yes |
| non_geo | query | Optional for applying a geolocation filter.. Request for offers that have not been assigned merchant addresses with geo-location(latitude/longitude) coordinates. At minimum, an origin must be also provided to call this flag. Accepts a boolean value - By default, the boolean value is set to false.  | No | boolean | form | Yes |
| contentid | query | Retrieve offers by their content ids. Provide an content id integer or a comma-delimited string of content id integers | No | string | form | Yes |
| offerid | query | Retrieve offers by their offer ids. Provide an offer id integer or a comma-delimited string of offer id integers | No | string | form | Yes |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | ok | **application/json**: { **"Offers"**: [ { **"bins"**: [ { **"ubid"**: integer, **"value"**: string, **"companyName"**: string } ], **"fAQs"**: { **"text"**: string, **"richText"**: string }, **"rpins"**: [ { **"ubid"**: integer, **"value"**: string, **"companyName"**: string, **"description"**: string } ], **"qrCode"**: { **"key"**: integer, **"description"**: string, **"imageAltTag"**: string, **"fileLocation"**: string, **"imageFileSize"**: string, **"imageFileWidth"**: string, **"imageFileHeight"**: string, **"imageResolution"**: string, **"offerImagePromotionChannels"**: [ object ], **"offerImagePromotionChannelIds"**: [ object ] }, **"barcode"**: { **"key"**: integer, **"description"**: string, **"imageAltTag"**: string, **"fileLocation"**: string, **"imageFileSize"**: string, **"imageFileWidth"**: string, **"imageFileHeight"**: string, **"imageResolution"**: string, **"offerImagePromotionChannels"**: [ object ], **"offerImagePromotionChannelIds"**: [ object ] }, **"offerId"**: integer, **"soldOut"**: boolean, **"language"**: string, **"supData1"**: { **"text"**: string, **"richText"**: string }, **"supData2"**: { **"text"**: string, **"richText"**: string }, **"supData3"**: { **"text"**: string, **"richText"**: string }, **"supData4"**: { **"text"**: string, **"richText"**: string }, **"imageList"**: [ { **"key"**: integer, **"description"**: string, **"imageAltTag"**: string, **"fileLocation"**: string, **"imageFileSize"**: string, **"imageFileWidth"**: string, **"imageFileHeight"**: string, **"imageResolution"**: string, **"offerImagePromotionChannels"**: [ object ], **"offerImagePromotionChannelIds"**: [ object ] } ], **"offerCopy"**: { **"text"**: string, **"richText"**: string }, **"offerType"**: [ { **"key"**: integer, **"value"**: string } ], **"programId"**: integer, **"visaTerms"**: { **"text"**: string, **"richText"**: string }, **"languageId"**: integer, **"offerTitle"**: string, **"shareTitle"**: string, **"binstorpins"**: [ { **"BIN"**: { **"ubid"**: integer, **"value"**: string, **"companyName"**: string }, **"RPIN"**: { **"ubid"**: integer, **"value"**: string, **"companyName"**: string, **"description"**: string } } ], **"indexNumber"**: integer, **"offerSource"**: string, **"offerStatus"**: string, **"programName"**: string, **"isOfferEvent"**: boolean, **"merchantList"**: [ { **"merchant"**: string, **"merchantId"**: integer, **"merchantImages"**: [ { **"key"**: integer, **"fileName"**: string, **"languages"**: [ object ], **"logoAltTag"**: string, **"description"**: string, **"languageIds"**: [ object ], **"promotionId"**: integer, **"fileLocation"**: string, **"promotionIds"**: [ object ], **"imageFileSize"**: string, **"imageFileWidth"**: string, **"imageFileHeight"**: string, **"imageResolution"**: string, **"promotionChannel"**: string, **"promotionChannels"**: [ object ] } ], **"merchantAddress"**: [ { **"key"**: integer, **"city"**: string, **"state"**: string, **"address1"**: string, **"address2"**: string, **"distance"**: string, **"latitude"**: string, **"languages"**: [ object ], **"longtitude"**: string, **"postalCode"**: string, **"countryName"**: string, **"indexNumber"**: integer, **"languageIds"**: [ object ], **"merchantKey"**: integer, **"languageName"**: string, **"merchantValue"**: string } ] } ], **"accountranges"**: [ { **"ubid"**: integer, **"valueTo"**: string, **"valueFrom"**: string, **"companyName"**: string } ], **"dateLocations"**: [ { **"city"**: string, **"state"**: string, **"endDate"**: string, **"address1"**: string, **"address2"**: string, **"latitude"**: string, **"isSoldOut"**: boolean, **"longitude"**: string, **"startDate"**: string, **"postalCode"**: string, **"countryName"**: string, **"dateLocationId"**: integer } ], **"eventSubTitle"**: string, **"merchantTerms"**: { **"text"**: string, **"richText"**: string }, **"offerMetadata"**: [ { **"metaId"**: integer, **"metaKey"**: string, **"metaValue"**: string } ], **"redemptionUrl"**: string, **"currentVersion"**: integer, **"offerContentId"**: integer, **"redemptionCode"**: string, **"validityToDate"**: string, **"activeIndicator"**: boolean, **"cardPaymentType"**: [ { **"key"**: integer, **"value"**: string } ], **"cardProductList"**: [ { **"key"**: integer, **"value"**: string } ], **"promotionToDate"**: string, **"redemptionEmail"**: string, **"validityFromDate"**: string, **"promotionFromDate"**: string, **"creativeGuidelines"**: string, **"offerSourceContact"**: string, **"promotingCountries"**: [ { **"key"**: integer, **"value"**: string } ], **"businessSegmentList"**: [ { **"key"**: integer, **"value"**: string } ], **"redemptionCountries"**: [ { **"key"**: integer, **"value"**: string } ], **"redemptionTelephone"**: { **"text"**: string, **"richText"**: string }, **"accountrangestorpins"**: [ { **"RPIN"**: { **"ubid"**: integer, **"value"**: string, **"companyName"**: string, **"description"**: string }, **"AccountRange"**: { **"ubid"**: integer, **"valueTo"**: string, **"valueFrom"**: string, **"companyName"**: string } } ], **"lastModifiedDateTime"**: string, **"promotionChannelList"**: [ { **"key"**: integer, **"value"**: string } ], **"promotionRestictions"**: { **"text"**: string, **"richText"**: string }, **"offerShortDescription"**: { **"text"**: string, **"richText"**: string }, **"redemptionChannelList"**: [ { **"key"**: integer, **"value"**: string } ], **"creativeApprovalsEmail"**: string, **"featuredOfferIndicator"**: boolean, **"legalCountryExclusions"**: { **"text"**: string, **"richText"**: string }, **"categorySubcategoryList"**: [ { **"key"**: integer, **"value"**: string, **"subcategories"**: [ { **"key"**: integer, **"value"**: string } ] } ], **"socialMediaSharingTypes"**: [ { **"key"**: integer, **"value"**: string } ], **"redemptionFormatInstructions"**: string } ], **"StartIndex"**: integer, **"ReturnedResults"**: integer, **"TotalFoundResults"**: integer }<br> |
| 400 | Invalid query |  |
| default | Unexpected error |  |

### [GET] /vmorc/offers/v1/byfilter
**List of Offers By Filter**

Retrieve a filtered set of offers by specifying reference criteria noted below. Reference data options in the same criteria apply an "OR" relationship and must be comma-separated in the request. Reference data options in different criteria apply an "AND" relationship and each data type is separated using an "&". The key identifiers of each available reference data option is returned through the reference data requests.

#### Parameters

| Name | Located in | Description | Required | Schema | Style | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ----- | ------- |
| start_index | query | A maximum of 500 offer results may be returned in the response. The parameter specifies the index of the total available offer results to start returning in the response.  | No | integer | form | Yes |
| max_offers | query | Optional. A maximum of 500 offer results are returned in the offer response. The index indicates the maximum number of offers to return in the response. Accepts an integer (greater than 0; less than or equal to 500). Default set to 500 | No | integer | form | Yes |
| business_segment | query | Filter offers by business segments. Provide one "key" integer or a comma-delimited string of "key" integers  Refer to <a href="/guides/request_response_codes#business_segments">business_segments</a> for sample values and keys. | No | string | form | Yes |
| card_payment_type | query | Filter offers by card payment types. Provide one "key" integer or a comma-delimited string of "key" integers  Refer to <a href="/guides/request_response_codes#card_payment_types">card_payment_types</a> for sample values and keys.  | No | string | form | Yes |
| card_product | query | Filter offers by card products. Provide one "key" integer or a comma-delimited string of "key" integers  Refer to <a href="/guides/request_response_codes#card_product">card_product</a> for sample values and keys. | No | string | form | Yes |
| category | query | Filter offers by offer categories. Provide one "key" integer or a comma-delimited string of "key" integers  Refer to <a href="/guides/request_response_codes#category_and_subcategory">category_subcategory</a> for sample values and keys.  | No | string | form | Yes |
| subcategory | query | Filter offers by offer subcategories. Provide one "key" integer or a comma-delimited string of "key" integers  Refer to <a href="/guides/request_response_codes#category_and_subcategory">category_subcategory</a> for sample values and keys.  | No | string | form | Yes |
| merchant | query | Filter offers by merchants. Provide one "key" integer or a comma-delimited string of "key" integers   Refer to <a href="/guides/request_response_codes#merchant">merchant</a> for sample values and keys. | No | string | form | Yes |
| program | query | Filter offers by programs. Provide one "key" integer or a comma-delimited string of "key" integers  Refer to <a href="/guides/request_response_codes#program">program</a> for sample values and keys. | No | string | form | Yes |
| promotion_channel | query | Filter offers by promotion channels. Provide one "key" integer or a comma-delimited string of "key" integers   Refer to <a href="/guides/request_response_codes#promotion_channel">promotion_channel</a> for sample values and keys. | No | string | form | Yes |
| promoting_region | query | Filter offers by promoting regions. Provide one "key" integer or a comma-delimited string of "key" integers  Refer to <a href="/guides/request_response_codes#region">region</a> for sample values and keys. | No | string | form | Yes |
| promoting_country | query | Filter offers by promoting countries. Provide one "key" integer or a comma-delimited string of "key" integers    Refer to <a href="/guides/request_response_codes#country">country</a> for sample values and keys. | No | string | form | Yes |
| redemption_region | query | Filter offers by redemption regions. Provide one "key" integer or a comma-delimited string of "key" integers    Refer to <a href="/guides/request_response_codes#region">region</a> for sample values and keys. | No | string | form | Yes |
| redemption_country | query | Filter offers by redemption countries. Provide one "key" integer or a comma-delimited string of "key" integers  Refer to <a href="/guides/request_response_codes#country">country</a> for sample values and keys. | No | string | form | Yes |
| merchant_region | query | Filter for offers that have been assigned a merchant address in at least one merchant address region parameter   Refer to <a href="/guides/request_response_codes#region">region</a> for sample values and keys. | No | string | form | Yes |
| merchant_county | query | Filter for offers that have been assigned a merchant address in at least one merchant address country parameter    Refer to <a href="/guides/request_response_codes#country">country</a> for sample values and keys. | No | string | form | Yes |
| language | query | Filter offers by offer languages. Provide one "key" integer or a comma-delimited string of "key" integers | No | string | form | Yes |
| expired | query | Request for expired offers. Provide a boolean value. Default set to value to "false". | No | boolean | form | Yes |
| validfrom | query | Request for offers where the offer's redemption end date is on or after the provided date (in GMT). Accepts a date formatted by: yyyyMMdd e.g. 1, If validfrom=20150101 is provided, this returns eligible offers that end on or after January 1, 2015 e.g. 2, If validfrom=20150101&validto=20150131, this will return eligible offers that end on or after January 1, 2015 and start on or before January 31, 2015 (valid during at least one day in January 2015). | No | string | form | Yes |
| validto | query | Request for offers where the offer’s redemption start date is before or on the provided date (in GMT). Accepts a date formatted   by: yyyyMMdd e.g. 1, If validto=20150131 is provided, this will     return eligible offers that start before or on January 31,       2015 e.g. 2, If validfrom=20150101&validto=20150131, this will return eligible offers that end on or after January 1, 2015 and start on or before January 31, 2015 (valid during at least one day in January 2015). | No | string | form | Yes |
| promotedfrom | query | Request for offers where the offer’s promotion end date is on or  after the provided date (in GMT). Accepts a date formatted by: yyyyMMdd e.g. 1, If promotedfrom=20150101 is provided, this will / return eligible offers where the promotion ends on or after January 1, 2015 e.g. 2, If promotedfrom=20150101&promotedto=20150131, this will return eligible offers where the promotion ends on or after January 1, 2015 and start on or before January 31, 2015 (promoted at least one day in January 2015). | No | string | form | Yes |
| promotedto | query | Request for offers where the offer’s promotion start date is before or on the provided date (in GMT). Accepts a date formatted by: yyyyMMdd e.g. 1, If promotedto=20150131 is provided, this will return eligible offers where the promotion starts before or on January 31, 2015 e.g. 2, If promotedfrom=20150101&promotedto=20150131, this will return eligible offers where the promotion ends on or after January 1, 2015 and start on or before January 31, 2015 (promoted at least one day in January 2015). | No | string | form | Yes |
| updatefrom | query | Request for offers where the provided date is before or on an offer’s last modified date/time (in GMT). Accepts a date formatted by: yyyyMMdd | No | string | form | Yes |
| updateto | query | Request for offers where the provided date is after or on an       offer’s last modified date/time (in GMT). Accepts a date     formatted by: yyyyMMdd | No | string | form | Yes |
| featured | query | Request for featured offers. Provide a boolean value. | No | boolean | form | Yes |
| bins | query | Request for offers that fulfill one or more BIN options by inputting the exact desired bin value(s). Comma-delimit for multiple values | No | string | form | Yes |
| rpins | query | Request for offers that fulfill one or more RPIN options by inputting the exact desired rpin value(s). Comma-delimit for multiple values | No | string | form | Yes |
| bins_to_rpins | query | Request for offers that fulfill one or more BIN to RPIN pairing options by inputting the exact desired bin value, a tilde("~"), and the exact rpin value. | No | string | form | Yes |
| accountranges | query | Request for offers that fulfill a specific Account Range by     providing either  a "from" prefix value OR a "to" prefix value OR a "from" and a "to" prefix values. Each provided prefix value   must be a minimum of 4 digits. Each account range request must contain a colon(":") to distinguish between the "from" and "to" values (even if only one boundary is provided). | No | string | form | Yes |
| accountranges_to_rpins | query | Request for offers that fulfill a specific Account Range to RPIN pairing by providing either a "from" prefix value ~ RPIN OR a "to" prefix value ~ RPIN OR a "from" and a "to" prefix values ~ RPIN. Each provided account range prefix value must be a minimum of 4 digits. Each account range portion of the request must contain a colon(":") to distinguish between the "from" and "to" values (even if only one boundary is provided). Use a tilde("~") to separate the account range from the exact desired rpin. | No | string | form | Yes |
| pans | query | Request for offers by PAN (must be a minimum of 16 digits). The provided PAN is padded-right with "0" to a length of 21 digits. The system returns the offers where the padded value is within the subset of at least one of the offer's account range assignments. | No | string | form | Yes |
| non_cardAttribute | query | Request for offers that do not have assignments to card attribute fields. Provide a boolean value. Default sets value to "false". | No | boolean | form | Yes |
| origin | query | Required for applying a geolocation filter. Input the origin by specifying the latitude, a comma (","), and the longitude. Coordinates must be inputted in decimal degree format. The accepted range for latitude is between -90 and 90, inclusive. The accepted range for longitude is between -180 and 180, inclusive. | No | string | form | Yes |
| radius | query | Optional for applying a geolocation filter.. A maximum radius of 1000 (kilometers) or 621.371 (miles) is accepted. Default sets to 60 miles (or 100 kilometers if the "unit" geolocation parameter has been set to "km"). | No | number | form | Yes |
| unit | query | Optional for applying a geolocation filter.. Indicate the distance unit of miles or kilometers. Default sets to miles. To use kilometers, specify "km". | No | number | form | Yes |
| non_geo | query | Optional for applying a geolocation filter.. Request for offers that have not been assigned merchant addresses with geo-location(latitude/longitude) coordinates. At minimum, an origin must be also provided to call this flag. Accepts a boolean value - By default, the boolean value is set to false.  | No | boolean | form | Yes |
| contentid | query | Retrieve offers by their content ids. Provide an content id integer or a comma-delimited string of content id integers | No | string | form | Yes |
| offerid | query | Retrieve offers by their offer ids. Provide an offer id integer or a comma-delimited string of offer id integers | No | string | form | Yes |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | ok | **application/json**: { **"Offers"**: [ { **"bins"**: [ { **"ubid"**: integer, **"value"**: string, **"companyName"**: string } ], **"fAQs"**: { **"text"**: string, **"richText"**: string }, **"rpins"**: [ { **"ubid"**: integer, **"value"**: string, **"companyName"**: string, **"description"**: string } ], **"qrCode"**: { **"key"**: integer, **"description"**: string, **"imageAltTag"**: string, **"fileLocation"**: string, **"imageFileSize"**: string, **"imageFileWidth"**: string, **"imageFileHeight"**: string, **"imageResolution"**: string, **"offerImagePromotionChannels"**: [ object ], **"offerImagePromotionChannelIds"**: [ object ] }, **"barcode"**: { **"key"**: integer, **"description"**: string, **"imageAltTag"**: string, **"fileLocation"**: string, **"imageFileSize"**: string, **"imageFileWidth"**: string, **"imageFileHeight"**: string, **"imageResolution"**: string, **"offerImagePromotionChannels"**: [ object ], **"offerImagePromotionChannelIds"**: [ object ] }, **"offerId"**: integer, **"soldOut"**: boolean, **"language"**: string, **"supData1"**: { **"text"**: string, **"richText"**: string }, **"supData2"**: { **"text"**: string, **"richText"**: string }, **"supData3"**: { **"text"**: string, **"richText"**: string }, **"supData4"**: { **"text"**: string, **"richText"**: string }, **"imageList"**: [ { **"key"**: integer, **"description"**: string, **"imageAltTag"**: string, **"fileLocation"**: string, **"imageFileSize"**: string, **"imageFileWidth"**: string, **"imageFileHeight"**: string, **"imageResolution"**: string, **"offerImagePromotionChannels"**: [ object ], **"offerImagePromotionChannelIds"**: [ object ] } ], **"offerCopy"**: { **"text"**: string, **"richText"**: string }, **"offerType"**: [ { **"key"**: integer, **"value"**: string } ], **"programId"**: integer, **"visaTerms"**: { **"text"**: string, **"richText"**: string }, **"languageId"**: integer, **"offerTitle"**: string, **"shareTitle"**: string, **"binstorpins"**: [ { **"BIN"**: { **"ubid"**: integer, **"value"**: string, **"companyName"**: string }, **"RPIN"**: { **"ubid"**: integer, **"value"**: string, **"companyName"**: string, **"description"**: string } } ], **"indexNumber"**: integer, **"offerSource"**: string, **"offerStatus"**: string, **"programName"**: string, **"isOfferEvent"**: boolean, **"merchantList"**: [ { **"merchant"**: string, **"merchantId"**: integer, **"merchantImages"**: [ { **"key"**: integer, **"fileName"**: string, **"languages"**: [ object ], **"logoAltTag"**: string, **"description"**: string, **"languageIds"**: [ object ], **"promotionId"**: integer, **"fileLocation"**: string, **"promotionIds"**: [ object ], **"imageFileSize"**: string, **"imageFileWidth"**: string, **"imageFileHeight"**: string, **"imageResolution"**: string, **"promotionChannel"**: string, **"promotionChannels"**: [ object ] } ], **"merchantAddress"**: [ { **"key"**: integer, **"city"**: string, **"state"**: string, **"address1"**: string, **"address2"**: string, **"distance"**: string, **"latitude"**: string, **"languages"**: [ object ], **"longtitude"**: string, **"postalCode"**: string, **"countryName"**: string, **"indexNumber"**: integer, **"languageIds"**: [ object ], **"merchantKey"**: integer, **"languageName"**: string, **"merchantValue"**: string } ] } ], **"accountranges"**: [ { **"ubid"**: integer, **"valueTo"**: string, **"valueFrom"**: string, **"companyName"**: string } ], **"dateLocations"**: [ { **"city"**: string, **"state"**: string, **"endDate"**: string, **"address1"**: string, **"address2"**: string, **"latitude"**: string, **"isSoldOut"**: boolean, **"longitude"**: string, **"startDate"**: string, **"postalCode"**: string, **"countryName"**: string, **"dateLocationId"**: integer } ], **"eventSubTitle"**: string, **"merchantTerms"**: { **"text"**: string, **"richText"**: string }, **"offerMetadata"**: [ { **"metaId"**: integer, **"metaKey"**: string, **"metaValue"**: string } ], **"redemptionUrl"**: string, **"currentVersion"**: integer, **"offerContentId"**: integer, **"redemptionCode"**: string, **"validityToDate"**: string, **"activeIndicator"**: boolean, **"cardPaymentType"**: [ { **"key"**: integer, **"value"**: string } ], **"cardProductList"**: [ { **"key"**: integer, **"value"**: string } ], **"promotionToDate"**: string, **"redemptionEmail"**: string, **"validityFromDate"**: string, **"promotionFromDate"**: string, **"creativeGuidelines"**: string, **"offerSourceContact"**: string, **"promotingCountries"**: [ { **"key"**: integer, **"value"**: string } ], **"businessSegmentList"**: [ { **"key"**: integer, **"value"**: string } ], **"redemptionCountries"**: [ { **"key"**: integer, **"value"**: string } ], **"redemptionTelephone"**: { **"text"**: string, **"richText"**: string }, **"accountrangestorpins"**: [ { **"RPIN"**: { **"ubid"**: integer, **"value"**: string, **"companyName"**: string, **"description"**: string }, **"AccountRange"**: { **"ubid"**: integer, **"valueTo"**: string, **"valueFrom"**: string, **"companyName"**: string } } ], **"lastModifiedDateTime"**: string, **"promotionChannelList"**: [ { **"key"**: integer, **"value"**: string } ], **"promotionRestictions"**: { **"text"**: string, **"richText"**: string }, **"offerShortDescription"**: { **"text"**: string, **"richText"**: string }, **"redemptionChannelList"**: [ { **"key"**: integer, **"value"**: string } ], **"creativeApprovalsEmail"**: string, **"featuredOfferIndicator"**: boolean, **"legalCountryExclusions"**: { **"text"**: string, **"richText"**: string }, **"categorySubcategoryList"**: [ { **"key"**: integer, **"value"**: string, **"subcategories"**: [ { **"key"**: integer, **"value"**: string } ] } ], **"socialMediaSharingTypes"**: [ { **"key"**: integer, **"value"**: string } ], **"redemptionFormatInstructions"**: string } ], **"StartIndex"**: integer, **"ReturnedResults"**: integer, **"TotalFoundResults"**: integer }<br> |
| 400 | Invalid query |  |
| default | Unexpected error |  |

### [GET] /vmorc/offers/v1/byofferid
**Retrieve Offers By Offer Id**

Retrieve the offer and any of its translations (if any exist). Each specified offerID may return one(if no translations exist) or more offer content objects. Query param "offerId" is required.

#### Parameters

| Name | Located in | Description | Required | Schema | Style | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ----- | ------- |
| start_index | query | A maximum of 500 offer results may be returned in the response. The parameter specifies the index of the total available offer results to start returning in the response.  | No | integer | form | Yes |
| max_offers | query | Optional. A maximum of 500 offer results are returned in the offer response. The index indicates the maximum number of offers to return in the response. Accepts an integer (greater than 0; less than or equal to 500). Default set to 500 | No | integer | form | Yes |
| business_segment | query | Filter offers by business segments. Provide one "key" integer or a comma-delimited string of "key" integers  Refer to <a href="/guides/request_response_codes#business_segments">business_segments</a> for sample values and keys. | No | string | form | Yes |
| card_payment_type | query | Filter offers by card payment types. Provide one "key" integer or a comma-delimited string of "key" integers  Refer to <a href="/guides/request_response_codes#card_payment_types">card_payment_types</a> for sample values and keys.  | No | string | form | Yes |
| card_product | query | Filter offers by card products. Provide one "key" integer or a comma-delimited string of "key" integers  Refer to <a href="/guides/request_response_codes#card_product">card_product</a> for sample values and keys. | No | string | form | Yes |
| category | query | Filter offers by offer categories. Provide one "key" integer or a comma-delimited string of "key" integers  Refer to <a href="/guides/request_response_codes#category_and_subcategory">category_subcategory</a> for sample values and keys.  | No | string | form | Yes |
| subcategory | query | Filter offers by offer subcategories. Provide one "key" integer or a comma-delimited string of "key" integers  Refer to <a href="/guides/request_response_codes#category_and_subcategory">category_subcategory</a> for sample values and keys.  | No | string | form | Yes |
| merchant | query | Filter offers by merchants. Provide one "key" integer or a comma-delimited string of "key" integers   Refer to <a href="/guides/request_response_codes#merchant">merchant</a> for sample values and keys. | No | string | form | Yes |
| program | query | Filter offers by programs. Provide one "key" integer or a comma-delimited string of "key" integers  Refer to <a href="/guides/request_response_codes#program">program</a> for sample values and keys. | No | string | form | Yes |
| promotion_channel | query | Filter offers by promotion channels. Provide one "key" integer or a comma-delimited string of "key" integers   Refer to <a href="/guides/request_response_codes#promotion_channel">promotion_channel</a> for sample values and keys. | No | string | form | Yes |
| promoting_region | query | Filter offers by promoting regions. Provide one "key" integer or a comma-delimited string of "key" integers  Refer to <a href="/guides/request_response_codes#region">region</a> for sample values and keys. | No | string | form | Yes |
| promoting_country | query | Filter offers by promoting countries. Provide one "key" integer or a comma-delimited string of "key" integers    Refer to <a href="/guides/request_response_codes#country">country</a> for sample values and keys. | No | string | form | Yes |
| redemption_region | query | Filter offers by redemption regions. Provide one "key" integer or a comma-delimited string of "key" integers    Refer to <a href="/guides/request_response_codes#region">region</a> for sample values and keys. | No | string | form | Yes |
| redemption_country | query | Filter offers by redemption countries. Provide one "key" integer or a comma-delimited string of "key" integers  Refer to <a href="/guides/request_response_codes#country">country</a> for sample values and keys. | No | string | form | Yes |
| merchant_region | query | Filter for offers that have been assigned a merchant address in at least one merchant address region parameter   Refer to <a href="/guides/request_response_codes#region">region</a> for sample values and keys. | No | string | form | Yes |
| merchant_county | query | Filter for offers that have been assigned a merchant address in at least one merchant address country parameter    Refer to <a href="/guides/request_response_codes#country">country</a> for sample values and keys. | No | string | form | Yes |
| language | query | Filter offers by offer languages. Provide one "key" integer or a comma-delimited string of "key" integers | No | string | form | Yes |
| expired | query | Request for expired offers. Provide a boolean value. Default set to value to "false". | No | boolean | form | Yes |
| validfrom | query | Request for offers where the offer's redemption end date is on or after the provided date (in GMT). Accepts a date formatted by: yyyyMMdd e.g. 1, If validfrom=20150101 is provided, this returns eligible offers that end on or after January 1, 2015 e.g. 2, If validfrom=20150101&validto=20150131, this will return eligible offers that end on or after January 1, 2015 and start on or before January 31, 2015 (valid during at least one day in January 2015). | No | string | form | Yes |
| validto | query | Request for offers where the offer’s redemption start date is before or on the provided date (in GMT). Accepts a date formatted   by: yyyyMMdd e.g. 1, If validto=20150131 is provided, this will     return eligible offers that start before or on January 31,       2015 e.g. 2, If validfrom=20150101&validto=20150131, this will return eligible offers that end on or after January 1, 2015 and start on or before January 31, 2015 (valid during at least one day in January 2015). | No | string | form | Yes |
| promotedfrom | query | Request for offers where the offer’s promotion end date is on or  after the provided date (in GMT). Accepts a date formatted by: yyyyMMdd e.g. 1, If promotedfrom=20150101 is provided, this will / return eligible offers where the promotion ends on or after January 1, 2015 e.g. 2, If promotedfrom=20150101&promotedto=20150131, this will return eligible offers where the promotion ends on or after January 1, 2015 and start on or before January 31, 2015 (promoted at least one day in January 2015). | No | string | form | Yes |
| promotedto | query | Request for offers where the offer’s promotion start date is before or on the provided date (in GMT). Accepts a date formatted by: yyyyMMdd e.g. 1, If promotedto=20150131 is provided, this will return eligible offers where the promotion starts before or on January 31, 2015 e.g. 2, If promotedfrom=20150101&promotedto=20150131, this will return eligible offers where the promotion ends on or after January 1, 2015 and start on or before January 31, 2015 (promoted at least one day in January 2015). | No | string | form | Yes |
| updatefrom | query | Request for offers where the provided date is before or on an offer’s last modified date/time (in GMT). Accepts a date formatted by: yyyyMMdd | No | string | form | Yes |
| updateto | query | Request for offers where the provided date is after or on an       offer’s last modified date/time (in GMT). Accepts a date     formatted by: yyyyMMdd | No | string | form | Yes |
| featured | query | Request for featured offers. Provide a boolean value. | No | boolean | form | Yes |
| bins | query | Request for offers that fulfill one or more BIN options by inputting the exact desired bin value(s). Comma-delimit for multiple values | No | string | form | Yes |
| rpins | query | Request for offers that fulfill one or more RPIN options by inputting the exact desired rpin value(s). Comma-delimit for multiple values | No | string | form | Yes |
| bins_to_rpins | query | Request for offers that fulfill one or more BIN to RPIN pairing options by inputting the exact desired bin value, a tilde("~"), and the exact rpin value. | No | string | form | Yes |
| accountranges | query | Request for offers that fulfill a specific Account Range by     providing either  a "from" prefix value OR a "to" prefix value OR a "from" and a "to" prefix values. Each provided prefix value   must be a minimum of 4 digits. Each account range request must contain a colon(":") to distinguish between the "from" and "to" values (even if only one boundary is provided). | No | string | form | Yes |
| accountranges_to_rpins | query | Request for offers that fulfill a specific Account Range to RPIN pairing by providing either a "from" prefix value ~ RPIN OR a "to" prefix value ~ RPIN OR a "from" and a "to" prefix values ~ RPIN. Each provided account range prefix value must be a minimum of 4 digits. Each account range portion of the request must contain a colon(":") to distinguish between the "from" and "to" values (even if only one boundary is provided). Use a tilde("~") to separate the account range from the exact desired rpin. | No | string | form | Yes |
| pans | query | Request for offers by PAN (must be a minimum of 16 digits). The provided PAN is padded-right with "0" to a length of 21 digits. The system returns the offers where the padded value is within the subset of at least one of the offer's account range assignments. | No | string | form | Yes |
| non_cardAttribute | query | Request for offers that do not have assignments to card attribute fields. Provide a boolean value. Default sets value to "false". | No | boolean | form | Yes |
| origin | query | Required for applying a geolocation filter. Input the origin by specifying the latitude, a comma (","), and the longitude. Coordinates must be inputted in decimal degree format. The accepted range for latitude is between -90 and 90, inclusive. The accepted range for longitude is between -180 and 180, inclusive. | No | string | form | Yes |
| radius | query | Optional for applying a geolocation filter.. A maximum radius of 1000 (kilometers) or 621.371 (miles) is accepted. Default sets to 60 miles (or 100 kilometers if the "unit" geolocation parameter has been set to "km"). | No | number | form | Yes |
| unit | query | Optional for applying a geolocation filter.. Indicate the distance unit of miles or kilometers. Default sets to miles. To use kilometers, specify "km". | No | number | form | Yes |
| non_geo | query | Optional for applying a geolocation filter.. Request for offers that have not been assigned merchant addresses with geo-location(latitude/longitude) coordinates. At minimum, an origin must be also provided to call this flag. Accepts a boolean value - By default, the boolean value is set to false.  | No | boolean | form | Yes |
| contentid | query | Retrieve offers by their content ids. Provide an content id integer or a comma-delimited string of content id integers | No | string | form | Yes |
| offerid | query | Retrieve offers by their offer ids. Provide an offer id integer or a comma-delimited string of offer id integers | No | string | form | Yes |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | ok | **application/json**: { **"Offers"**: [ { **"bins"**: [ { **"ubid"**: integer, **"value"**: string, **"companyName"**: string } ], **"fAQs"**: { **"text"**: string, **"richText"**: string }, **"rpins"**: [ { **"ubid"**: integer, **"value"**: string, **"companyName"**: string, **"description"**: string } ], **"qrCode"**: { **"key"**: integer, **"description"**: string, **"imageAltTag"**: string, **"fileLocation"**: string, **"imageFileSize"**: string, **"imageFileWidth"**: string, **"imageFileHeight"**: string, **"imageResolution"**: string, **"offerImagePromotionChannels"**: [ object ], **"offerImagePromotionChannelIds"**: [ object ] }, **"barcode"**: { **"key"**: integer, **"description"**: string, **"imageAltTag"**: string, **"fileLocation"**: string, **"imageFileSize"**: string, **"imageFileWidth"**: string, **"imageFileHeight"**: string, **"imageResolution"**: string, **"offerImagePromotionChannels"**: [ object ], **"offerImagePromotionChannelIds"**: [ object ] }, **"offerId"**: integer, **"soldOut"**: boolean, **"language"**: string, **"supData1"**: { **"text"**: string, **"richText"**: string }, **"supData2"**: { **"text"**: string, **"richText"**: string }, **"supData3"**: { **"text"**: string, **"richText"**: string }, **"supData4"**: { **"text"**: string, **"richText"**: string }, **"imageList"**: [ { **"key"**: integer, **"description"**: string, **"imageAltTag"**: string, **"fileLocation"**: string, **"imageFileSize"**: string, **"imageFileWidth"**: string, **"imageFileHeight"**: string, **"imageResolution"**: string, **"offerImagePromotionChannels"**: [ object ], **"offerImagePromotionChannelIds"**: [ object ] } ], **"offerCopy"**: { **"text"**: string, **"richText"**: string }, **"offerType"**: [ { **"key"**: integer, **"value"**: string } ], **"programId"**: integer, **"visaTerms"**: { **"text"**: string, **"richText"**: string }, **"languageId"**: integer, **"offerTitle"**: string, **"shareTitle"**: string, **"binstorpins"**: [ { **"BIN"**: { **"ubid"**: integer, **"value"**: string, **"companyName"**: string }, **"RPIN"**: { **"ubid"**: integer, **"value"**: string, **"companyName"**: string, **"description"**: string } } ], **"indexNumber"**: integer, **"offerSource"**: string, **"offerStatus"**: string, **"programName"**: string, **"isOfferEvent"**: boolean, **"merchantList"**: [ { **"merchant"**: string, **"merchantId"**: integer, **"merchantImages"**: [ { **"key"**: integer, **"fileName"**: string, **"languages"**: [ object ], **"logoAltTag"**: string, **"description"**: string, **"languageIds"**: [ object ], **"promotionId"**: integer, **"fileLocation"**: string, **"promotionIds"**: [ object ], **"imageFileSize"**: string, **"imageFileWidth"**: string, **"imageFileHeight"**: string, **"imageResolution"**: string, **"promotionChannel"**: string, **"promotionChannels"**: [ object ] } ], **"merchantAddress"**: [ { **"key"**: integer, **"city"**: string, **"state"**: string, **"address1"**: string, **"address2"**: string, **"distance"**: string, **"latitude"**: string, **"languages"**: [ object ], **"longtitude"**: string, **"postalCode"**: string, **"countryName"**: string, **"indexNumber"**: integer, **"languageIds"**: [ object ], **"merchantKey"**: integer, **"languageName"**: string, **"merchantValue"**: string } ] } ], **"accountranges"**: [ { **"ubid"**: integer, **"valueTo"**: string, **"valueFrom"**: string, **"companyName"**: string } ], **"dateLocations"**: [ { **"city"**: string, **"state"**: string, **"endDate"**: string, **"address1"**: string, **"address2"**: string, **"latitude"**: string, **"isSoldOut"**: boolean, **"longitude"**: string, **"startDate"**: string, **"postalCode"**: string, **"countryName"**: string, **"dateLocationId"**: integer } ], **"eventSubTitle"**: string, **"merchantTerms"**: { **"text"**: string, **"richText"**: string }, **"offerMetadata"**: [ { **"metaId"**: integer, **"metaKey"**: string, **"metaValue"**: string } ], **"redemptionUrl"**: string, **"currentVersion"**: integer, **"offerContentId"**: integer, **"redemptionCode"**: string, **"validityToDate"**: string, **"activeIndicator"**: boolean, **"cardPaymentType"**: [ { **"key"**: integer, **"value"**: string } ], **"cardProductList"**: [ { **"key"**: integer, **"value"**: string } ], **"promotionToDate"**: string, **"redemptionEmail"**: string, **"validityFromDate"**: string, **"promotionFromDate"**: string, **"creativeGuidelines"**: string, **"offerSourceContact"**: string, **"promotingCountries"**: [ { **"key"**: integer, **"value"**: string } ], **"businessSegmentList"**: [ { **"key"**: integer, **"value"**: string } ], **"redemptionCountries"**: [ { **"key"**: integer, **"value"**: string } ], **"redemptionTelephone"**: { **"text"**: string, **"richText"**: string }, **"accountrangestorpins"**: [ { **"RPIN"**: { **"ubid"**: integer, **"value"**: string, **"companyName"**: string, **"description"**: string }, **"AccountRange"**: { **"ubid"**: integer, **"valueTo"**: string, **"valueFrom"**: string, **"companyName"**: string } } ], **"lastModifiedDateTime"**: string, **"promotionChannelList"**: [ { **"key"**: integer, **"value"**: string } ], **"promotionRestictions"**: { **"text"**: string, **"richText"**: string }, **"offerShortDescription"**: { **"text"**: string, **"richText"**: string }, **"redemptionChannelList"**: [ { **"key"**: integer, **"value"**: string } ], **"creativeApprovalsEmail"**: string, **"featuredOfferIndicator"**: boolean, **"legalCountryExclusions"**: { **"text"**: string, **"richText"**: string }, **"categorySubcategoryList"**: [ { **"key"**: integer, **"value"**: string, **"subcategories"**: [ { **"key"**: integer, **"value"**: string } ] } ], **"socialMediaSharingTypes"**: [ { **"key"**: integer, **"value"**: string } ], **"redemptionFormatInstructions"**: string } ], **"StartIndex"**: integer, **"ReturnedResults"**: integer, **"TotalFoundResults"**: integer }<br> |
| 400 | Invalid query |  |
| default | Unexpected error |  |
